unit setup;
{$ifdef FPC}{$mode objfpc}{$h+}{$endif}
interface
uses
 mseglob,mseguiglob,mseguiintf,mseapplication,msestat,msemenus,msegui,
 msegraphics,msegraphutils,mseevent,mseclasses,mseforms,msedock,msedispwidgets,
 mserichstring,msestrings,msetypes,msedataedits,mseedit,mseifiglob,
 msesimplewidgets,msewidgets,msegraphedits;

type
 tsetupfo = class(tdockform)
   btOk: trichbutton;
   slBrightness: tslider;
   idBrightness: tintegerdisp;
   slContrast: tslider;
   idContrast: tintegerdisp;
   slSatur: tslider;
   idSatur: tintegerdisp;
   btClose: trichbutton;
   procedure formOnClose(const sender: TObject);
   procedure btCloseOnClick(const sender: TObject);
   procedure formOnCreate(const sender: TObject);
   procedure slBrightnessOnSetvalue(const sender: TObject; var avalue: realty;
                   var accept: Boolean);
   procedure btOkOnClick(const sender: TObject);
   procedure slContrastOnSetValue(const sender: TObject; var avalue: realty;
                   var accept: Boolean);
   procedure slSaturOnSetValue(const sender: TObject; var avalue: realty;
                   var accept: Boolean);
 private
 	fchanged: boolean;
 	fbrightness: integer;
 	fcontrast: integer;
 	fsaturation: integer;
 	
 	procedure setBrightness(const val: integer);
 	procedure setContrast(const val: integer);
 	procedure setSaturation(const val: integer);
 public
 	property brightness: integer read fbrightness write setBrightness;
 	property contrast: integer read fcontrast write setContrast;
 	property saturation: integer read fsaturation write setSaturation;
 	property changed: boolean read fchanged write fchanged;
 end;
var
 setupfo: tsetupfo;
 
 
implementation
uses
 setup_mfm;

procedure tsetupfo.setBrightness(const val: integer);
begin
	if (val >=0) then
	begin
		fbrightness := val;
		idBrightness.value := val;
		slBrightness.value := val / 100.0;
	end;
end;


procedure tsetupfo.setContrast(const val: integer);
begin
	if (val >=0) then
	begin
		fcontrast := val;
		idContrast.value := val;
		slContrast.value := val / 100.0;
	end;
end;

procedure tsetupfo.setSaturation(const val: integer);
begin
	if (val >=0) then
	begin
		fsaturation := val;
		idSatur.value := val;
		slSatur.value := val / 100.0;
	end;
end;


procedure tsetupfo.formOnClose(const sender: TObject);
begin
	//self.destroy;
end;

procedure tsetupfo.btCloseOnClick(const sender: TObject);
begin
	self.close;
end;

procedure tsetupfo.formOnCreate(const sender: TObject);
begin
	fbrightness := 50;
	fcontrast := 50;
	fsaturation:= 50;
	fchanged := false;
end;

procedure tsetupfo.slBrightnessOnSetvalue(const sender: TObject;
               var avalue: realty; var accept: Boolean);
begin
		idBrightness.value := round(100*avalue);
		accept := true;
end;

procedure tsetupfo.btOkOnClick(const sender: TObject);
begin
	fbrightness := round(slBrightness.value * 100.0);
	fcontrast := round(slContrast.value * 100.0);
	fsaturation := round(slSatur.value * 100.0);
	fchanged := true;
end;

procedure tsetupfo.slContrastOnSetValue(const sender: TObject;
               var avalue: realty; var accept: Boolean);
begin
		idContrast.value := round(100*avalue);
		accept := true;
end;

procedure tsetupfo.slSaturOnSetValue(const sender: TObject; var avalue: realty;
               var accept: Boolean);
begin
		idSatur.value := round(100*avalue);
		accept := true;
end;


end.
